var objOSB =
{
	InArray: function(objItem, aTestArray)
	{
		for (var objIndex in aTestArray)
		{
			if (objItem == aTestArray[objIndex]) return objIndex;
		}

		return false;
	},

	InitServices: function()
	{
		window.removeEventListener('load', objOSB.InitServices, false);

		objOSB.prefService = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('organizestatusbar.');
		objOSB.ndStatusBar = document.getElementById('status-bar');
		objOSB.ndStatusBar.addEventListener('DOMNodeInserted', objOSB.ModifiedStatusBar, false);
		objOSB.ndStatusBar.addEventListener('DOMNodeRemoved', objOSB.ModifiedStatusBar, false);

		objOSB.bContentLoaded = false;
		objOSB.aDefaultItemList = [];
		objOSB.aDefaultCollapsed = {};

		objOSB.InitOrganize();
	},

	InitOrganize: function()
	{
		objOSB.Init();
		objOSB.Organize(null);

		return true;
	},

	Init: function()
	{
		objOSB.aDefaultCollapsed = {};

		var ctr;
		var nNoID = 0;
		var aPref = [];
		var aCurrentID = [];

		if (objOSB.prefService.prefHasUserValue('StatusBar'))
		{
			aPref = objOSB.prefService.getCharPref('StatusBar').split(',');
			for (ctr = 0; ctr < aPref.length; ++ctr)
			{
				aCurrentID.push(aPref[ctr].split(':')[0]);
			}
		}

		var aStatusBarPanels = objOSB.ndStatusBar.childNodes;
		for (ctr = 0; ctr < aStatusBarPanels.length; ++ctr)
		{
			if ((aStatusBarPanels[ctr].nodeName == 'keyset')
			|| (aStatusBarPanels[ctr].nodeName == 'toolbar')
			|| (aStatusBarPanels[ctr].nodeName == 'stringbundle')
			|| (aStatusBarPanels[ctr].nodeName == 'menupopup')
			|| (aStatusBarPanels[ctr].nodeName == 'popup'))
			{
				continue;
			}

			if ((aStatusBarPanels[ctr].id == null) || (aStatusBarPanels[ctr].id == '')) aStatusBarPanels[ctr].id = 'osb-noid-' + nNoID++;
			objOSB.aDefaultCollapsed[aStatusBarPanels[ctr].id] = (objOSB.InArray(aStatusBarPanels[ctr].id + ':0', aPref) === false) && ((aStatusBarPanels[ctr].getAttribute('collapsed') === true) || (aStatusBarPanels[ctr].getAttribute('collapsed') == 'true'));
			if (objOSB.InArray(aStatusBarPanels[ctr].id + ':1', objOSB.aDefaultItemList) === false) objOSB.aDefaultItemList.push(aStatusBarPanels[ctr].id + ':1');
			if (objOSB.InArray(aStatusBarPanels[ctr].id, aCurrentID) === false) aPref.push(aStatusBarPanels[ctr].id + ':1');
		}

		objOSB.prefService.setCharPref('StatusBar', aPref.join(','));

		return true;
	},

	Organize: function(aItemList)
	{
		if (!aItemList) aItemList = objOSB.prefService.getCharPref('StatusBar').split(',');

		objOSB.ndStatusBar.removeEventListener('DOMNodeInserted', objOSB.ModifiedStatusBar, false);
		objOSB.ndStatusBar.removeEventListener('DOMNodeRemoved', objOSB.ModifiedStatusBar, false);

		var ndOrderItem;
		for (var ctr = 0; ctr < aItemList.length; ++ctr)
		{
			if (document.getElementById(aItemList[ctr].split(':')[0]))
			{
				ndOrderItem = document.getElementById(aItemList[ctr].split(':')[0]);
				if (ndOrderItem.parentNode && (ndOrderItem.parentNode == objOSB.ndStatusBar))
				{
					ndOrderItem.removeEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
					if (aItemList[ctr].split(':')[1] == '0')
					{
						ndOrderItem.setAttribute('collapsed', true);
					}
					else
					{
						ndOrderItem.setAttribute('collapsed', objOSB.aDefaultCollapsed[ndOrderItem.id]);
					}

					var ndInserted = objOSB.ndStatusBar.appendChild(objOSB.ndStatusBar.removeChild(ndOrderItem));
					ndInserted.removeEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
					ndInserted.addEventListener('DOMAttrModified', objOSB.ModifiedAttribute, false);
				}
			}
		}

		objOSB.ndStatusBar.addEventListener('DOMNodeInserted', objOSB.ModifiedStatusBar, false);
		objOSB.ndStatusBar.addEventListener('DOMNodeRemoved', objOSB.ModifiedStatusBar, false);

		return true;
	},

	ModifiedAttribute: function(e)
	{
		var aPref = objOSB.prefService.getCharPref('StatusBar').split(',');
		if ((objOSB.InArray(e.target.id + ':0', aPref) !== false) && (e.attrName == 'collapsed') && (!e.newValue || (e.newValue == 'false'))) e.target.setAttribute('collapsed', true);

		return true;
	},

	ModifiedStatusBar: function(e)
	{
		if (!e.target.parentNode) return true;
		if (e.target.parentNode.id != 'status-bar') return true;

		objOSB.Init();
		if ((objOSB.InArray(e.target.id + ':1', objOSB.aDefaultItemList) !== false)) objOSB.Organize(null);

		return true;
	},

	Options: function()
	{
		window.openDialog('chrome://osb/content/osbOptions.xul', 'osb-options-dialog', 'centerscreen,chrome,modal');

		return true;
	}
};

window.addEventListener('load', objOSB.InitServices, false);
